Index: channels/chan_zap.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_zap.c,v
retrieving revision 1.326
diff -u -r1.326 chan_zap.c
--- channels/chan_zap.c	30 Aug 2004 05:07:27 -0000	1.326
+++ channels/chan_zap.c	30 Aug 2004 14:29:30 -0000
@@ -4135,7 +4135,12 @@
 	if (index == SUB_REAL) {
 		switch(condition) {
 		case AST_CONTROL_BUSY:
-			res = tone_zone_play_tone(p->subs[index].zfd, ZT_TONE_BUSY);
+#ifdef ZAPATA_PRI
+			if (p->sig == SIG_PRI)
+				res = pri_hangup(p->pri->pri, p->call, PRI_CAUSE_USER_BUSY);
+			else
+#endif
+				res = tone_zone_play_tone(p->subs[index].zfd, ZT_TONE_BUSY);
 			break;
 		case AST_CONTROL_RINGING:
 #ifdef ZAPATA_PRI
@@ -4198,7 +4203,12 @@
 			break;
 		case AST_CONTROL_CONGESTION:
 			chan->hangupcause = AST_CAUSE_CONGESTION;
-			res = tone_zone_play_tone(p->subs[index].zfd, ZT_TONE_CONGESTION);
+#ifdef ZAPATA_PRI
+			if (p->sig == SIG_PRI)
+				res = pri_hangup(p->pri->pri, p->call, PRI_CAUSE_SWITCH_CONGESTION);
+			else
+#endif
+				res = tone_zone_play_tone(p->subs[index].zfd, ZT_TONE_CONGESTION);
 			break;
 		case AST_CONTROL_RADIO_KEY:
 			if (p->radio) 
